       subroutine dmean(x,npts)
c-----
c       remove the mean from the time series.
c       Note this will usually remove the DC offset of the
c       trace, but for a one sided pulse this may seriously
c       affect the trace and its spectrum
c-----
c       x       R*4       - time series array
c       npts       I*4       - numbe of samples
c-----
       integer*4 npts
       real*4 x(npts)
       real*8 dsum
c-----
c       remove the mean
c-----
       if(npts.gt.1)then
              dsum  = 0.0d+00
              do 1000 i=1,npts
                     dsum = dsum + dble(x(i))
 1000              continue
              dsum = dsum / npts
              xmean = sngl (dsum)
              do 2000 i= 1, npts
                     x(i) = x(i) - xmean
 2000              continue
       endif
       return
       end

